<template>
  <div>
    <h2 class="font-medium" :class="{ 'text-lg': !isContact }">{{ question.title }}</h2>
    <el-text v-if="question.subtitle">{{ question.subtitle }}</el-text>
    <div class="mt-4">
      <el-checkbox-group v-model="checkList" class="grid grid-cols-2">
        <template v-for="ans in options">
          <el-checkbox class="!whitespace-normal " v-if="ans.isActive(userAnswers)" size="large" :label="ans.name">{{
            ans.title
          }}</el-checkbox>
        </template>
      </el-checkbox-group>
    </div>
  </div>
</template>

<script setup>
import { ref, watch, computed } from 'vue'
import { defineType } from '../data'
import optionsData from '../data/options'

const props = defineProps({
  question: {
    type: Object
  },
  userAnswers: {
    type: Array
  },
  handleUserAnswer: {
    type: Function
  },
  isContact: {
    type: Boolean,
    default: false
  }
})

const getOptionsByQuestionName = (questionName) => {
  return optionsData.filter((item) => item.parent === questionName)
}

const options = computed(() => getOptionsByQuestionName(props.question.name))

const findValueCheckList = () => {
  const index = props.userAnswers.findIndex((item) => item.question.name == props.question.name)
  let value = []
  if (index !== -1) {
    value = props.userAnswers[index][defineType.multi]
  }

  return value
}

const checkList = ref(findValueCheckList())

const updateMultiChoice = () => {
  props.handleUserAnswer({
    question: props.question,
    ans: checkList.value
  })
}

watch(
  () => props.question,
  () => {
    checkList.value = findValueCheckList()
  }
)

watch(checkList, () => {
  updateMultiChoice()
})
</script>
